VERSION 5.00
Begin VB.Form frmpathfind 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Wegfindung mit dem Algorithmus von Dijkstra"
   ClientHeight    =   10005
   ClientLeft      =   150
   ClientTop       =   750
   ClientWidth     =   14100
   Icon            =   "frmpathfind.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   10005
   ScaleWidth      =   14100
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar hscrollcarspeed 
      Height          =   255
      LargeChange     =   15
      Left            =   11520
      Max             =   30
      TabIndex        =   7
      Top             =   5760
      Value           =   5
      Width           =   2535
   End
   Begin VB.Timer tmrcalcduration 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   11520
      Top             =   6720
   End
   Begin VB.Timer tmrdrivecar 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   11520
      Top             =   8640
   End
   Begin VB.Frame frameactions 
      Caption         =   "Aktionen"
      Height          =   5295
      Left            =   11520
      TabIndex        =   1
      Top             =   0
      Width           =   2535
      Begin VB.CommandButton cmddriveway 
         Caption         =   "Weg abfahren"
         Height          =   495
         Left            =   120
         TabIndex        =   12
         Top             =   3960
         Width           =   2295
      End
      Begin VB.CommandButton cmdcalcshortpath 
         Caption         =   "Krzesten Weg berechnen"
         Height          =   495
         Left            =   120
         TabIndex        =   11
         Top             =   3360
         Width           =   2295
      End
      Begin VB.CommandButton cmdcalcgraph 
         Caption         =   "Graph erstellen"
         Height          =   495
         Left            =   120
         TabIndex        =   10
         Top             =   2760
         Width           =   2295
      End
      Begin VB.OptionButton optmoveobst 
         Caption         =   "Hindernis bewegen"
         Height          =   495
         Left            =   120
         Style           =   1  'Grafisch
         TabIndex        =   9
         Top             =   1440
         Width           =   2295
      End
      Begin VB.OptionButton optobst 
         Caption         =   "Hindernis erstellen"
         Height          =   495
         Left            =   120
         Style           =   1  'Grafisch
         TabIndex        =   5
         Top             =   240
         Value           =   -1  'True
         Width           =   2295
      End
      Begin VB.OptionButton optmovenode 
         Caption         =   "Start-, Zielknoten bewegen"
         Height          =   495
         Left            =   120
         Style           =   1  'Grafisch
         TabIndex        =   4
         Top             =   2040
         Width           =   2295
      End
      Begin VB.OptionButton optdelobst 
         Caption         =   "Hindernis lschen"
         Height          =   495
         Left            =   120
         Style           =   1  'Grafisch
         TabIndex        =   3
         Top             =   840
         Width           =   2295
      End
      Begin VB.CommandButton cmdreset 
         Caption         =   "Reset"
         Height          =   495
         Left            =   120
         TabIndex        =   2
         Top             =   4680
         Width           =   2295
      End
   End
   Begin VB.PictureBox picbg 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      FillStyle       =   0  'Ausgefllt
      Height          =   9975
      Left            =   0
      MousePointer    =   2  'Kreuz
      ScaleHeight     =   9915
      ScaleWidth      =   11355
      TabIndex        =   0
      Top             =   0
      Width           =   11415
      Begin VB.Image imgcar 
         Height          =   525
         Left            =   10080
         Picture         =   "frmpathfind.frx":0152
         Top             =   7920
         Visible         =   0   'False
         Width           =   960
      End
   End
   Begin VB.Label lblcarspeed 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Geschwindigkeit: 75"
      Height          =   255
      Left            =   11520
      TabIndex        =   8
      ToolTipText     =   "bewegt Auto alle 50 Millisekunden um den Wert"
      Top             =   5400
      Width           =   2535
   End
   Begin VB.Label lblmessage 
      Alignment       =   2  'Zentriert
      BackStyle       =   0  'Transparent
      Caption         =   "Linke Maustaste drcken, Maus bewegen und Maustaste loslassen, um ein Hindernis zu erstellen"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   3855
      Left            =   11520
      TabIndex        =   6
      Top             =   6120
      Width           =   2535
   End
   Begin VB.Menu mnufile 
      Caption         =   "&Datei"
      Index           =   0
      Begin VB.Menu mnuend 
         Caption         =   "&Beenden"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmpathfind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'_________________________________________________________
'Dieses Modul enthlt alle Prozedure, die direkt mit der
'grafischen Benutzer-Oberflche
'bzw. Darstellung zu tun haben
'
'cmdcalcgraph_Click()
'cmdcalcshortpath_Click()
'cmddriveway_Click()
'cmdreset_Click
'Form_Load()
'Form_MouseMove(...)
'hscrollcarspeed_Change()
'optdelobst_Click()
'optobst_Click()
'optmovenode_Click()
'optmoveobst_Click()
'picbg_MouseDown(...)
'picbg_MouseUp(...)
'picbg_MouseMove(...)
'tmrcalcduration_Timer()
'tmrdrivecar_Timer()
'
'DrawCursorCross()
'DrawNodes()
'DrawEdges()
'DrawObstacles()
'_________________________________________________________
'

Private Sub cmdcalcgraph_Click()
    ResetGraph
    SetGraph
    lTimeCounter = 0                         'Zeitmessung beginnen
    frmpathfind.tmrcalcduration.Enabled = True
    RemoveCutEdges
    frmpathfind.tmrcalcduration.Enabled = False   'Zeitmessung beenden, Ergebnis anzeigen
    If lTimeCounter = 0 Then
        frmpathfind.lblmessage.Caption = "Rechendauer: weniger als 1 Millisekunde"
    Else
        frmpathfind.lblmessage.Caption = "Rechendauer: " & lTimeCounter & " Millisekunden"
    End If
    
    picbg.Cls                           'alte Anzeige lschen
    DrawCursorCross                     'Fadenkreuz
    DrawEdges                           'Kanten zeichnen
    DrawNodes                           'Knoten zeichnen
    DrawObstacles                       'Hindernisse zeichnen
End Sub

Private Sub cmdcalcshortpath_Click()
    ShortestPath lStartNodeIndex
    picbg.Cls                           'alte Anzeige lschen
    DrawCursorCross                     'Fadenkreuz
    DrawEdges                           'Kanten zeichnen
    DrawNodes                           'Knoten zeichnen
    DrawObstacles                       'Hindernisse zeichnen
End Sub

Private Sub cmddriveway_Click()
    If Not bShortestWaysReady Then cmdcalcshortpath_Click
    If dDistance(lDestNodeIndex) = cINFINITY Then
        lblmessage.Caption = "Zielknoten ist nicht mit dem Startknoten verbunden"
        Exit Sub            'Kann eigentlich nicht passieren, aber wer wei?
    Else
        frameactions.Enabled = False
        lLastNodeIndex = lStartNodeIndex
        lNextNodeIndex = lStartNodeIndex
        dCarPosX = Nodes(lNextNodeIndex).XPos
        dCarPosY = Nodes(lNextNodeIndex).YPos
        imgcar.Visible = True
        tmrdrivecar.Enabled = True
        tmrdrivecar_Timer
    End If
End Sub

Private Sub cmdreset_Click()
    Erase Obstacles
    lCountObsts = 0
    ResetGraph
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyN Then
        frmpathfind.Caption = "Nchster Knoten: " & FindNextNode(lActMousePosX, lActMousePosY)
    End If
End Sub

Private Sub Form_Load()
    
    SetNode 1500, 8000                          'Start- und Zielknoten
    SetNode 8500, 1500
    lStartNodeIndex = 0
    lDestNodeIndex = 1
    dCarSpeed = hscrollcarspeed.Value * 15
    lblcarspeed.Caption = "Geschwindigkeit: " & dCarSpeed
    lMoveIndex = -1
    DrawNodes                           'Knoten zeichnen
    
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bCreateObst = False
    bDragState = False
End Sub

Private Sub hscrollcarspeed_Change()
    dCarSpeed = hscrollcarspeed.Value * 15
    lblcarspeed.Caption = "Geschwindigkeit: " & dCarSpeed
End Sub

Private Sub mnuend_Click(Index As Integer)
    End
End Sub

Private Sub optdelobst_Click()
    lblmessage.Caption = "Auf Mitte des zu lschenden Hindernisses klicken"
End Sub

Private Sub optmovenode_Click()
    lblmessage.Caption = "Start- und Zielknoten per Drag und Drop bewegen"
End Sub

Private Sub optmoveobst_Click()
    lblmessage.Caption = "Start- und Endknoten der Hindernisse per Drag und Drop bewegen"
End Sub

Private Sub optobst_Click()
    lblmessage.Caption = "Hindernis mit erstellen mit linke Maustaste drcken, Maus bewegen und linke Maustaste loslassen"
End Sub

Private Sub picbg_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim n As Long, m As Long
    Dim dShortestDistance As Double, dTemp As Double, lShortestIndex As Long
    
    If Not frameactions.Enabled Then Exit Sub   'keine Aktion whrend der Autofahrt!
    If Button = vbLeftButton Then
        If optobst.Value Then                   'Hindernis erstellen (Anfang)
            bCreateObst = True
            lDragStartX = X
            lDragStartY = Y
        ElseIf optdelobst.Value Then            'Hindernis lschen
            If lCountObsts < 1 Then
                optobst.Value = True
                lblmessage.Caption = "Keine Hindernisse vorhanden"
                Exit Sub
            End If
            
            dShortestDistance = cINFINITY
            For n = 0 To lCountObsts - 1
                dTemp = PythA((Obstacles(n).X1Pos + Obstacles(n).X2Pos) / 2 - lActMousePosX, _
                             (Obstacles(n).Y1Pos + Obstacles(n).Y2Pos) / 2 - lActMousePosY)
                If dTemp < dShortestDistance Then
                    dShortestDistance = dTemp
                    lShortestIndex = n
                End If
            Next n
            RemoveObstacle lShortestIndex
            bShortestWaysReady = False
        ElseIf optmoveobst.Value Then           'Hindernis bewegen
            If lCountObsts < 1 Then
                optobst.Value = True
                lblmessage.Caption = "Keine Hindernisse vorhanden"
                Exit Sub
            End If
            
            dShortestDistance = cINFINITY
            For n = 0 To lCountObsts - 1
                dTemp = PythA(Obstacles(n).X1Pos - lActMousePosX, Obstacles(n).Y1Pos - lActMousePosY)
                If dTemp < dShortestDistance Then
                    dShortestDistance = dTemp
                    lShortestIndex = n
                    lMoveObstStartNode = True
                End If
            Next n
            
            For n = 0 To lCountObsts - 1
                dTemp = PythA(Obstacles(n).X2Pos - lActMousePosX, Obstacles(n).Y2Pos - lActMousePosY)
                If dTemp < dShortestDistance Then
                    dShortestDistance = dTemp
                    lShortestIndex = n
                    lMoveObstStartNode = False
                End If
            Next n
            lMoveIndex = lShortestIndex
            
            bShortestWaysReady = False
        ElseIf optmovenode.Value Then           'Start- oder Zielknoten bewegen
            If PythA(Nodes(lStartNodeIndex).XPos - lActMousePosX, Nodes(lStartNodeIndex).YPos - lActMousePosY) < _
               PythA(Nodes(lDestNodeIndex).XPos - lActMousePosX, Nodes(lDestNodeIndex).YPos - lActMousePosY) Then
                lMoveIndex = lStartNodeIndex
            Else
                lMoveIndex = lDestNodeIndex
            End If
            bShortestWaysReady = False
        End If
    End If
    
End Sub

Private Sub picbg_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not frameactions.Enabled Then Exit Sub   'keine Aktion whrend der Autofahrt!
    If Button = vbLeftButton Then
        bCreateObst = False
        If optobst.Value Then
            'Hindernis erstellen (Ende)
            If PythA(lDragStartX - X, lDragStartY - Y) > 150 Then 'nur Hindernisse, die Lnger als 10 Pixel sind
                SetObst lDragStartX, lDragStartY, X, Y
                picbg.Cls                           'alte Anzeige lschen
                DrawCursorCross                     'Fadenkreuz
                DrawEdges                           'Kanten zeichnen
                DrawNodes                           'Knoten zeichnen
                DrawObstacles                       'Hindernisse zeichnen
                bShortestWaysReady = False
            End If
        End If
    End If
    lMoveIndex = -1
End Sub

Private Sub picbg_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If Not frameactions.Enabled Then Exit Sub
    
    If lMoveIndex > -1 Then               'ausgewhltes Objekt bewegen
        If optmovenode.Value Then
            Nodes(lMoveIndex).XPos = lActMousePosX
            Nodes(lMoveIndex).YPos = lActMousePosY
            bShortestWaysReady = False
        ElseIf optmoveobst.Value Then
            If lMoveObstStartNode Then
                Obstacles(lMoveIndex).X1Pos = lActMousePosX
                Obstacles(lMoveIndex).Y1Pos = lActMousePosY
            Else
                Obstacles(lMoveIndex).X2Pos = lActMousePosX
                Obstacles(lMoveIndex).Y2Pos = lActMousePosY
            End If
            bShortestWaysReady = False
        End If
    End If
    lActMousePosX = X                   'Mauspositionen aktualisieren
    lActMousePosY = Y
    frmpathfind.Caption = "Wegfindung mit dem Algorithmus von Dijkstra | X: " & lActMousePosX & " | Y: " & lActMousePosY
    
    picbg.Cls                           'alte Anzeige lschen
    
    DrawCursorCross                     'Fadenkreuz
        
    DrawEdges                           'Kanten zeichnen
    
    DrawNodes                           'Knoten zeichnen
    
    DrawObstacles                       'Hindernisse zeichnen
        
End Sub

Private Sub tmrcalcduration_Timer()
    lTimeCounter = lTimeCounter + 1
End Sub

Private Sub tmrdrivecar_Timer()
    
    Dim n As Long
    
    Form_MouseMove 0, 0, 0, 0
    
    If PythA(dCarPosX - Nodes(lNextNodeIndex).XPos, dCarPosY - Nodes(lNextNodeIndex).YPos) <= dCarSpeed Then
                                            'Knoten erreicht
        If lNextNodeIndex = lDestNodeIndex Then  'Endziel erreicht?
            frameactions.Enabled = True
            tmrdrivecar.Enabled = False
            imgcar.Visible = False
            picbg.Cls                           'alte Anzeige lschen
            DrawCursorCross                     'Fadenkreuz
            DrawEdges                           'Kanten zeichnen
            DrawNodes                           'Knoten zeichnen
            DrawObstacles                       'Hindernisse zeichnen
        Else                                    'Zwischenziel erreicht
            'Auto zum Knoten setzen, weil sich die Ungenauigkeit sonst ansammelt
            dCarPosX = Nodes(lNextNodeIndex).XPos
            dCarPosY = Nodes(lNextNodeIndex).YPos
            
            n = lDestNodeIndex                  'nchster Zwischenknoten?
            Do Until lToNode(n) = lNextNodeIndex
                n = lToNode(n)
            Loop
            lLastNodeIndex = lToNode(n)
            lNextNodeIndex = n
            
            lCurrentEdgeIndex = Nodes(lLastNodeIndex).ConnectedOverEdge(lNextNodeIndex)
            
            'Bewegungsrichtung berechnen
            dgegkat = Nodes(lNextNodeIndex).YPos - Nodes(lLastNodeIndex).YPos
            dankat = Nodes(lNextNodeIndex).XPos - Nodes(lLastNodeIndex).XPos
            If dankat = 0 Then           'gegen berlauf / division durch 0
                If dgegkat > 0 Then
                    dDirection = cPI / 2
                Else
                    dDirection = -cPI / 2
                End If
            Else
                dDirection = Atn(dgegkat / dankat)
            End If
            
            'neu zeichnen
            picbg.Cls
            DrawCursorCross
            DrawEdges
            DrawNodes
            DrawObstacles
            
        End If
    End If
            
    'ber Kante von lLastNodeIndex zu lNextNodeIndex bewegen
    If dankat < 0 Then
        dCarPosX = dCarPosX - dCarSpeed * Cos(dDirection)
        dCarPosY = dCarPosY - dCarSpeed * Sin(dDirection)
    Else
        dCarPosX = dCarPosX + dCarSpeed * Cos(dDirection)
        dCarPosY = dCarPosY + dCarSpeed * Sin(dDirection)
    End If
    
    
    imgcar.Left = dCarPosX - imgcar.Width / 2
    imgcar.Top = dCarPosY - imgcar.Height - 3
    
    'Wenn ein Fehler auftritt (Auto fhrt aus dem Bildbereich)
    If imgcar.Left > picbg.Width Or imgcar.Left + imgcar.Width < 0 Or imgcar.Top > picbg.Height Or imgcar.Top + imgcar.Height < 0 Then
        MsgBox "Sorry, es funktioniert anscheinend immer noch nicht." & vbCrLf & _
                "dDirection = " & dDirection
        frameactions.Enabled = True
        tmrdrivecar.Enabled = False
        imgcar.Visible = False
    End If
    
End Sub

Public Sub DrawCursorCross()
    
    If lActMousePosX = -1 Or lActMousePosY = -1 Then Exit Sub         'Wenn Maus berm Bildbereich

    picbg.DrawStyle = 2
    picbg.Line (lActMousePosX, 0)-(lActMousePosX, picbg.Height), QBColor(8)  '|   senkrechte Linie
    picbg.Line (0, lActMousePosY)-(picbg.Width, lActMousePosY), QBColor(8)  '-    waagerechte Linie
    
End Sub

Public Sub DrawNodes()
    
    Dim n As Long
    
    If bShortestWaysReady Then
        picbg.FillColor = vbGreen   'Startknoten hervorheben
        picbg.Circle (Nodes(lStartNodeIndex).XPos, _
                      Nodes(lStartNodeIndex).YPos), 105, vbGreen
    End If
    If tmrdrivecar.Enabled Then
        picbg.FillColor = vbRed     'Zielknoten hervorheben
        picbg.Circle (Nodes(lDestNodeIndex).XPos, _
                      Nodes(lDestNodeIndex).YPos), 105, vbRed
    End If
    For n = 0 To lCountNodes - 1      'alle Knoten zeichnen
        picbg.FillColor = vbBlack
        picbg.Circle (Nodes(n).XPos, Nodes(n).YPos), 50, vbBlack
    Next n
    
End Sub

Public Sub DrawEdges()
    
    Dim n As Long, lTemp As Long
    
    If lCountEdges = -1 Then Exit Sub
    
    If tmrdrivecar.Enabled Then
        n = lDestNodeIndex                 'Fahrtweg markieren
        Do Until n = lStartNodeIndex
            lTemp = Nodes(lToNode(n)).ConnectedOverEdge(n)
            With Edges(lTemp)
                If lTemp = lCurrentEdgeIndex Then
                    picbg.DrawWidth = 6
                    picbg.Line (Nodes(.StartNodeIndex).XPos, Nodes(.StartNodeIndex).YPos)- _
                               (Nodes(.EndNodeIndex).XPos, Nodes(.EndNodeIndex).YPos), vbYellow
                End If
                
                picbg.DrawWidth = 3
                picbg.Line (Nodes(.StartNodeIndex).XPos, Nodes(.StartNodeIndex).YPos)- _
                           (Nodes(.EndNodeIndex).XPos, Nodes(.EndNodeIndex).YPos), vbBlack
                picbg.DrawWidth = 1
            End With
            n = lToNode(n)
            DoEvents
        Loop
    End If
    
    For n = 0 To lCountEdges - 1            'alle Kanten zeichnen
        With Edges(n)
            picbg.DrawStyle = 0                                         'Linien
            picbg.Line (Nodes(.StartNodeIndex).XPos, Nodes(.StartNodeIndex).YPos)- _
                       (Nodes(.EndNodeIndex).XPos, Nodes(.EndNodeIndex).YPos), vbBlack
        End With
    Next n
    
End Sub

Public Sub DrawObstacles()
    
    Dim n As Long
    
    If bCreateObst Then                                                 'Hindernis bei der Entstehung zeichnen
        picbg.DrawStyle = 0                                             'Linien
        picbg.DrawWidth = 3
        picbg.Line (lDragStartX, lDragStartY)- _
                   (lActMousePosX, lActMousePosY), vbRed
        picbg.DrawWidth = 1
    End If
    
    For n = 0 To lCountObsts - 1
        With Obstacles(n)
            picbg.DrawStyle = 0                                         'Linien
            picbg.DrawWidth = 4
            picbg.Line (.X1Pos, .Y1Pos)- _
                       (.X2Pos, .Y2Pos), QBColor(8)
            picbg.DrawWidth = 1
        End With
    Next n
    
End Sub

Public Function FindNextNode(lFromX As Long, lFromY As Long)
    'nchsten Knoten von einer Position, hier meist Mausposition mit Pythagoras ermitteln
    
    Dim lLowestDistance As Long, lDistance As Double, n As Long
    
    On Error GoTo seterrorcode
    
    lLowestDistance = -1
    
    If lCountNodes = 0 Then GoTo seterrorcode
    For n = 0 To lCountNodes - 1
        lDistance = PythA(lFromX - Nodes(n).XPos, lFromY - Nodes(n).YPos)
        If lLowestDistance = -1 Or lLowestDistance > lDistance Then
            lLowestDistance = lDistance
            FindNextNode = n
        End If
    Next n
    
seterrorcode:
    If lLowestDistance = -1 Then FindNextNode = -1
    
End Function

